=== debian/control ===
Source: ros-melodic-fuse-models
Section: misc
Priority: optional
Maintainer: Tom Moore <tmoore@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libbenchmark-dev, libboost-all-dev, libceres-dev, libeigen3-dev, ros-melodic-catkin, ros-melodic-fuse-constraints, ros-melodic-fuse-core, ros-melodic-fuse-graphs, ros-melodic-fuse-msgs, ros-melodic-fuse-publishers, ros-melodic-fuse-variables, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-2d, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-fuse-models
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libceres-dev, libeigen3-dev, ros-melodic-fuse-constraints, ros-melodic-fuse-core, ros-melodic-fuse-graphs, ros-melodic-fuse-msgs, ros-melodic-fuse-publishers, ros-melodic-fuse-variables, ros-melodic-geometry-msgs, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-2d, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros
Description: fuse plugins that implement various kinematic and sensor models
